Subject: [bug#57070] [PATCH] bootloader: extlinux: support for optional FDTDIR

From: Pavel Shlyak <[email-masked]>
Date: Mon, 22 Aug 2022 13:52:08 +0300

> If the user really wants to choose a different DT, they can customise their kernel by overriding the sourcce.
Yes, unless it’s generated by bootloader.
> why not submit the bootloader DT to the kernel?
Because it passes board-specific parameters. We cannot submit DTs for all board revisions, memory sizes etc.
> Likewise, if they are equivalent, I don't see the point either.
They are not
> You write that the system definition can both boot with the kernel-provided FDT and bootloader FDT, then why are you writing this patch if things work?
It can boot on RPI4b, but not on RPI3b+ or Compute Module 4
> The kernel has multiple DTs. I assume that, somehow, the kernel can figure out which one.
DTs are loaded by the bootloader. Kernel cannot figure anything out.
> If you must go for this work-around, you could try porting the logic that the kernel
No, kernel does not include this logic
> AFAIK, device tree information is used by the kernel, not the bootloader.
Uboot uses DT on some platforms
> I don't see the point if updating the DT in the kernel appears to be sufficient.
I hope dynamic DT with some data that only bootloader can know is sufficient for you. Again, this is how things work on Raspberry and some other boards on any distro. We don’t support that - we don’t support these devices. I personally don’t loose much as we can apply this patch directly on pantherx channel, making pantherx richer in device support. However, I do not quite like the idea of me answering «Install PantherX» to the people who cannot get GUIX on their devices.

I would be also happy if someone more competent on the topic joined this discussion.